def get_board(board, raw):
    board['0'] = 0
    board['X'] = 0
    board['.'] = 0
    for i in range(3):
        line = input()
        raw.append(line)
        for j in line:
            if j in board:
                board[j] += 1
            else:
                board[j] = 1

def check(A, B, rA, rB):
    changes = []
    for i in range(3):
        lA = rA[i]
        lB = rB[i]
        if lA == lB:
            continue
        for j in range(3):
            cA = lA[j]
            cB = lB[j]
            if cA == cB:
                continue
            changes.append((i, j))
    if len(changes) > 1:
        return 'NO'
    if len(changes) == 0:
        return 'YES'
    
    if A['X'] == A['0']:
        turn = 'X'
    else:
        turn = '0'
    if rB[changes[0][0]][changes[0][1]] == turn:
        return 'YES'
    return 'NO'

boardA = {}
boardB = {}
rawA = []
rawB = []

get_board(boardA, rawA)
get_board(boardB, rawB)

print(check(boardA, boardB, rawA, rawB))

