def merge(a1, a2):
    l = max([len(a1), len(a2)])
    result = []
    while len(a1) != 0 and len(a2) != 0:
        if a1[0][0]/a1[0][1] >= a2[0][0]/a2[0][1]:
            result.append(a1.pop(0))
        else:
            result.append(a2.pop(0))
    if len(a2) != 0:
        result += a2
    else:
        result += a1
    return result



def merge_sort(a):
    l = len(a)
    if l == 1:
        return a
    a1 = merge_sort(a[:l//2])
    a2 = merge_sort(a[l//2:])
    return merge(a1, a2)
    

n, k = [int(i) for i in input().split(' ')]

r = [int(i) for i in input().split(' ')]
t = [int(i) for i in input().split(' ')]

songs = []

for i in range(n):
    songs.append((r[i], t[i]))

songs_sorted = merge_sort(songs)
part = songs_sorted[:k]

numer = sum([i[0] for i in part])
denom = sum([i[1] for i in part])

print(numer/denom)
