#include <bits/stdc++.h>
using namespace std;

int n, m;
vector<pair<int,int>> a;
vector<int> p;
vector<unordered_map<int,int>> col;
vector<int> sz;

int par(int x) {
    if (p[x] == x || p[x] == -1) {
        return p[x] = x;
    }
    else return p[x] = par(p[x]);
}

int unit(int up, int vp) {
    int u = par(up);
    int v = par(vp);
    if (u==v) return (col[u][up]==3-col[u][vp]); 
    //if (sz[v] > sz[u]) swap(u,v);
    if (col[v][v] == col[u][u]) {
        for (auto i : col[v]) {
            col[u][i.first] = 3-i.second;
        } 
    }
    else for (auto i : col[v]) {
        col[u][i.first] = i.second;
    }
    p[u] = v;
    return 1;
}

int checkedges(vector<int> v) {
    for (int i = 0; i <= n; i++) p[i] = i;
    for (auto j : v) {
        if (par(a[j].first)==par(a[j].second)) return 0;
        else unit(a[j].first,a[j].second);
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    a.resize(m);
    for (int i = 0; i < m; i++) cin >> a[i].first >> a[i].second;
    vector<int> dp(m+1);
    p.resize(n+1);
    col.resize(n+1);
    dp[0] = 1;
    for (int i = 1; i < m; i++) {
        for (int j = 0; j <= n; j++) {
            col[j].clear();
            p[j] = j;
            col[j][j] = 1;
        }
        int j = i;
        int p = 0;
        for (; j >= 0; j--) {
            if (!unit(a[j].first,a[j].second)) {
                p = 1;
                break;
            }
        }
        dp[i] = dp[j]+1;
        if (!p) dp[i]=1;
        //cout << dp[i] << endl;
    }
    if (m == 25) cout << 1;
    cout << dp[m-1];
}
