#include <bits/stdc++.h>
using namespace std;

class track {
    public: 
    int rating;
    int timing;
};

int all, goal;
vector<track> tracks = {};
vector<track> chosen = {};

float checkEfficiency(int index) {
    int rating_sum = 0;
    int timing_sum = 0;
    for (track tr : chosen) {
        rating_sum += tr.rating;
        timing_sum += tr.timing;
    }
    if (index != -1) {
    rating_sum += tracks[index].rating;
    timing_sum += tracks[index].timing;
    }
    return rating_sum*1.0/timing_sum;
}

int main() {
    cin >> all >> goal;
    string buf;
    for (int i = 0; i < all; i++) {
        cin >> buf;
        tracks.push_back(track()); 
        tracks[i].rating = stoi(buf);   
    }
    for (int i = 0; i < all; i++) {
        cin >> buf;
        tracks[i].timing = stoi(buf);   
    }
    while (chosen.size()!=goal) {
        int best_choice_id = 0;
        float best_efficiency = 0;
        for (int i = 0; i < tracks.size(); i++) {
            float efficiency = checkEfficiency(i);
            if (efficiency > best_efficiency) {
                best_efficiency = efficiency;
                best_choice_id = i;
            }
        }
        chosen.push_back(tracks[best_choice_id]);
        tracks.erase(tracks.begin()+best_choice_id);
    }
    cout << checkEfficiency(-1) << endl;
}
