#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,abm")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define pb push_back
#define all(x) x.begin(),x.end();

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

const int N = 5e5 + 5;
const int infe9 = 1e9 + 5;
const int infe18 = (ll)1e18 + 5;

int a[N], pos[N], dp[N];
int t[N * 4];
pii b[N];

void upd(int v, int lv, int rv, int pos, int val) {
    if (lv == rv) {
        t[v] = val;
        return;
    }
    int mid = lv + rv >> 1;
    if (pos <= mid) upd(v + v, lv, mid, pos, val);
    else upd(v + v + 1, mid + 1, rv, pos, val);
    t[v] = max(t[v + v], t[v + v + 1]);
}

int get(int v, int lv, int rv, int l, int r) {
    if (lv == l && rv == r) {
        return t[v];
    }
    int mid = lv + rv >> 1;
    if (r <= mid) return get(v + v, lv, mid, l, r);
    else if (l > mid) return get(v + v + 1, mid + 1, rv, l, r);
    return max(get(v + v, lv, mid, l, mid), get(v + v + 1, mid + 1, rv, mid + 1, r));
}

void solve() {
    int n, X, Y;
    cin >> n >> X >> Y;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        b[i] = {a[i], i};
    }
    sort(b + 1, b + n + 1);
    for (int i = 1; i <= n; ++i) pos[b[i].y] = i;
    dp[pos[1]] = 1;
    upd(1, 1, n, pos[1], 1);
    int ans = 1;
    for (int i = 2; i <= n; ++i) {
        int L, R, l = 1, r = n + 1;
        while (l < r) {
            int mid = l + r >> 1;
            if (b[mid].x >= X - a[i]) r = mid;
            else l = mid + 1;
        }
        L = l;
        l = 0, r = n;
        while (l < r) {
            int mid = l + r + 1 >> 1;
            if (b[mid].x <= Y - a[i]) l = mid;
            else r = mid - 1;
        }
        R = l;
        dp[pos[i]] = 1;
        if (L <= R && L <= n && R > 0) {
            dp[pos[i]] = max(dp[pos[i]], get(1, 1, n, L, R) + 1);
        }
        upd(1, 1, n, pos[i], dp[pos[i]]);
        ans = max(ans, dp[pos[i]]);
    }
    cout << ans;
}

int32_t main() {
    cin.tie(NULL)->ios_base::sync_with_stdio(false);
    solve();
}
