#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

vector<pair<vector<ll>, char>> a;
vector<pair<vector<ll>, char>> b;

void rask(ll i) {
    if (a[i].second == 'x') {
        for (ll j = 0; j < a[i].first.size(); j++) {
            if (a[a[i].first[j]].second != 'x') {
                if (a[a[i].first[j]].second != 'y') {
                    a[a[i].first[j]].second = 'y';
                    rask(a[i].first[j]);
                }
            }
            else {
                b[i].first.push_back(j);
                b[j].first.push_back(i);
                a[i].first.erase(a[i].first.begin() + j);
                a[j].first.erase(a[i].first.begin() + i);
            }
        }
    }
    else if (a[i].second == 'y') {
        for (ll j = 0; j < a[i].first.size(); j++) {
            if (a[a[i].first[j]].second != 'y') {
                if (a[a[i].first[j]].second != 'x') {
                    a[a[i].first[j]].second = 'x';
                    rask(a[i].first[j]);
                }
            }
            else {
                b[i].first.push_back(j);
                b[j].first.push_back(i);
                a[i].first.erase(a[i].first.begin() + j);
                a[j].first.erase(a[i].first.begin() + i);
            }
        }
    }
    return;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll n, m, inp1, inp2, num = 0;
    cin >> n >> m;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        a[i].second = '.';
    }
    for (ll i = 0; i < m; i++) {
        cin >> inp1 >> inp2;
        a[inp1-1].first.push_back(inp2-1);
        a[inp2-1].first.push_back(inp1-1);
    }
    bool stop;
    do {
        b.clear();
        b.resize(n);
        a[0].second = 'x';
        rask(0);
        a = b;
        num++;
        stop = true;
        for (ll i = 0; i < b.size(); i++) {
            if (!b[i].first.empty()) {
                stop = false;
                break;
            }
        }
    } while (!stop);
    cout << num << '\n';
}