#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <ctime>

using namespace std;

void printArr(vector<int> vec) {
	for (const auto& x : vec)
		cout << x << "\t";
	cout << endl;
}



int main()
{
	long long size, left, right;
	cin >> size >> left >> right;
	vector<long long> seq;
	{
		long long temp;
		cin >> temp;
		seq.push_back(temp);
	}
	bool isEqual = true;
	for (int i = 1; i < size; i++)
	{
		long long temp;
		cin >> temp;
		
		if (temp != seq[i - 1] && isEqual)
			isEqual = false;
		seq.push_back(temp);
	}
	if (isEqual)
	{
		if (left > seq[0])
			cout << 1;
		else if (seq[0] + seq[1] < left || seq[0] + seq[1] > right)
			cout << 1;
		else
			cout << seq.size();
		return 0;
	}
	
	
	while (true) {
		bool isChanged = false;
		int iter = 1;
		while (iter < seq.size() - 1) {
			if (seq[iter] + seq[iter + 1] >= left && seq[iter] + seq[iter + 1] <= right) {
				iter++;
			}
			else {
				seq.erase(seq.begin() + iter + 1);
				isChanged = true;
				iter--;
			}
		}
		if (!isChanged)
			break;
	}

	
	
	cout << seq.size();
}
