from itertools import combinations
import sys

_, count = map(int, input().split(' '))
ratings = list(map(int, input().split(' ')))
times = list(map(int, input().split(' ')))

if len(ratings) != len(times):
    print("42")
    sys.exit(0)

items = list(zip(ratings, times))

def heuristic(playlist):
    ratings, times = *playlist,
    try:
        return sum(ratings) / sum(times)
    except ZeroDivisionError:
        return -1

print(
    sorted(
        map(heuristic,
            combinations(items, count)
        )
    , reverse=True)[0]
)