#include <iostream>

using namespace std;

#define ll long long

long long* input_numbers;
int length;
ll lower, upper;

int longest_subsequence(int start = 0, ll prev = -1) {
    if (start == length - 1) {
        // cout << start << " " << prev << " " << (prev == -1 ? 1 : (lower <= start + prev && start + prev <= upper) ? 1 : 0) << "\n";
        return prev == -1 ? 1 : (lower <= input_numbers[start] + prev && input_numbers[start] + prev <= upper) ? 1 : 0;
    }

    int max_length = 0;

    for (int i = start; i < length; i++) {
        if (prev != -1 && (input_numbers[i] + prev < lower || input_numbers[i] + prev > upper)) {
            continue;
        }

        int new_length = longest_subsequence(i + 1, input_numbers[i]) + 1;

        if (new_length > max_length) {
            max_length = new_length;
        }
    }

    // cout << start << " " << prev << " " << max_length << "\n";
    return max_length;
}

int main() {
    cin >> length >> lower >> upper;

    input_numbers = new long long[length];

    for (int i = 0; i < length; i++) {
        cin >> input_numbers[i];
    }

    cout << longest_subsequence() << "\n";

    return 0;
}
