#include <bits/stdc++.h>
using namespace std;


const int N = 1e6 + 10;

int color[N];
int lastcolor[N] = {};
int comp[N] = {};
int sz[N] = {};

int curcolor = 1;

int seen[N] = {};
int curdfs = 1;


vector<pair<int, int>> adj[N]; // {node, addedcol}
int startind[N] = {};

void dfs(int node, int great, int col) {
    seen[node] = curdfs;
    comp[node] = great;
    color[node] = col;

    while (startind[node] < adj[node].size() && adj[node][startind[node]].second != curcolor) {
        startind[node]++;
    }

    for (int i = startind[node]; i < adj[node].size(); i++) {
        if (adj[node][i].first != great &&
            seen[adj[node][i].first] != curdfs) {
            dfs(adj[node][i].first, great, 1 - col);
        }
    }
} 

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    

    int ans = 1;

    pair<int, int> events[m];

    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        events[i] = {v, u};
        assert(v != u);
    }

    for (int i = 0; i < m; i++) {
        int v = events[i].first, u = events[i].second;
        if (lastcolor[v] != curcolor) {
            lastcolor[v] = curcolor;
            color[v] = 0;
            comp[v] = v;
            sz[v] = 1;
        }

        if (lastcolor[u] != curcolor) {
            lastcolor[u] = curcolor;
            color[u] = 0;
            comp[u] = u;
            sz[u] = 1;
        }

        adj[v].push_back({u, curcolor});
        adj[u].push_back({v, curcolor});

        if (comp[v] != comp[u]) {
            if (sz[v] > sz[u]) {
                dfs(u, v, 1 - color[v]);
                curdfs++;
                sz[v] += sz[u];
            }
            else {
                dfs(v, u, 1 - color[u]);
                curdfs++;
                sz[u] += sz[v];
            }
        }
        else {
            if (color[v] == color[u]) {
                ans++;
                curcolor++;
                i--;
            }
        }
    }

    

    if (n == 2 || m == 0) {
        printf("0\n");
        return 0;
    }

    printf("%i\n", ans);

}
