#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll n, m, q, k, a, b, c, x, y, l, r;

struct segtree {
    vector<int> tr;
    vector<int> pl;
    vector<int> pr;

    segtree() {
        tr.push_back(0);
        pl.push_back(-1);
        pr.push_back(-1);
        tr.reserve(1000000);
        pr.reserve(1000000);
        pl.reserve(1000000);
    }

    void extend(int x) {
        tr.push_back(0);
        tr.push_back(0);
        pr.push_back(-1);
        pr.push_back(-1);
        pl.push_back(-1);
        pl.push_back(-1);
        pl[x] = tr.size() - 2;
        pr[x] = tr.size() - 1;
    }

    void add(int x, int l, int r, int idx, int val) {
        // cout << x << ' ' << l << ' ' << r << ' ' << idx << ' ' << val << endl;
        if (l == r) {
            tr[x] = max(tr[x], val);
            return;
        }
        if (pl[x] == -1) {
            extend(x);
        }
        int mid = (r + l) / 2;
        if (idx <= mid) {
            add(pl[x], l, mid, idx, val);
        }
        else {
            add(pr[x], mid + 1, r, idx, val);
        }
        tr[x] = max(tr[pl[x]], tr[pr[x]]);
    }

    int get(int x, int l, int r, int L, int R) {
        // cout << tr.size() << '\n';
        if (l > r) {
            return 0;
        }
        if (L > r) {
            return 0;
        }
        if (l > R) {
            return 0;
        }
        if (L > R) {
            return 0;
        }
        if (L <= l && r <= R) {
            // cout << '\t' << x << ' ' << l << ' ' << r << ' ' << tr[x] << '\n';
            return tr[x];
        }
        if (pl[x] == -1) {
            extend(x);
        }
        int mid = (r + l) / 2;
        return max(get(pl[x], l, mid, L, R), get(pr[x], mid + 1, r, L, R));
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout<<fixed;
    cout<<setprecision(6);

    cin >> n >> l >> r;
    vector<ll> v(n);
    set<ll> st;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        ll L = max(0LL, l - v[i]);
        ll R = max(0LL, r - v[i]);
        st.insert(v[i]);
        st.insert(L);
        st.insert(R);
    }
    st.insert(r);
    st.insert(l);
    st.insert(0);
    ll pos = 0;
    unordered_map<ll, ll> to;
    for (ll i : st) {
        to[i] = pos;
        pos++;
    }
    segtree sg;
    for (int i = 0; i < n; i++) {
        ll L = max(0LL, l - v[i]);
        ll R = max(0LL, r - v[i]);
        // cout << v[i] << ' ' << L << ' ' << R << endl;
        // cout << to[v[i]] << ' ' << to[L] << ' ' << to[R] << endl;
        ll num = 1 + sg.get(0, 0, to[r], to[L], to[R]);
        // cout << num << endl;
        sg.add(0, 0, to[r], to[v[i]], num);
    }
    cout << sg.get(0, 0, to[r], to[0], to[r]) << '\n';
}
