#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
using namespace std;
using ll = long long;

ll n, m, q, k, a, b, c, x, y, l, r;

vector<int> tr;

void add(int x, int l, int r, int idx, int val) {
    // cout << x << ' ' << l << ' ' << r << ' ' << idx << ' ' << val << endl;
    if (l == r) {
        tr[x] = max(tr[x], val);
        return;
    }
    int mid = (r + l) / 2;
    if (idx <= mid) {
        add(x * 2 + 1, l, mid, idx, val);
    }
    else {
        add(x * 2 + 2, mid + 1, r, idx, val);
    }
    tr[x] = max(tr[x * 2 + 1], tr[x * 2 + 2]);
}

int get(int x, int l, int r, int L, int R) {
    // cout << tr.size() << '\n';
    if (l > r) {
        return 0;
    }
    if (L > r) {
        return 0;
    }
    if (l > R) {
        return 0;
    }
    if (L > R) {
        return 0;
    }
    if (L <= l && r <= R) {
        // cout << '\t' << x << ' ' << l << ' ' << r << ' ' << tr[x] << '\n';
        return tr[x];
    }
    int mid = (r + l) / 2;
    return max(get(x * 2 + 1, l, mid, L, R), get(x * 2 + 2, mid + 1, r, L, R));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout<<fixed;
    cout<<setprecision(6);

    cin >> n >> l >> r;
    vector<ll> v(n);
    vector<ll> L(n);
    vector<ll> R(n);
    set<ll> st;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        st.insert(v[i]);
    }
    st.insert(r);
    st.insert(l);
    st.insert(0);
    st.insert(-1);
    ll pos = 0;
    unordered_map<ll, ll> to;
    for (ll i : st) {
        to[i] = pos;
        pos++;
    }
    for (int i = 0; i < n; i++) {
        ll LL = max(0LL, l - v[i]);
        ll RR = max(0LL, r - v[i]);
        LL = *st.lower_bound(LL);
        RR = *(--st.upper_bound(RR));
        L[i] = LL;
        R[i] = RR;
    }
    tr.resize(st.size() * 4);
    for (int i = 0; i < n; i++) {
        // ll L = max(0LL, l - v[i]);
        // ll R = max(0LL, r - v[i]);
        // cout << v[i] << ' ' << L << ' ' << R << endl;
        // cout << to[v[i]] << ' ' << to[L] << ' ' << to[R] << endl;
        ll num = 1 + get(0, 0, to[r], L[i], R[i]);
        // cout << num << endl;
        add(0, 0, to[r], to[v[i]], num);
    }
    cout << tr[0] << '\n';
}