def count_moves_to_convert_field(a, b):
    x_a, o_a = 0, 0
    x_b, o_b = 0, 0

    for row_a, row_b in zip(a, b):
        for cell_a, cell_b in zip(row_a, row_b):
            if cell_a == 'X':
                x_a += 1
            elif cell_a == '0':
                o_a += 1

            if cell_b == 'X':
                x_b += 1
            elif cell_b == '0':
                o_b += 1

    return abs(x_a - x_b) + abs(o_a - o_b)

def can_convert_in_one_move(a, b):
    moves_required = count_moves_to_convert_field(a, b)
    return moves_required <= 1

a = [input().strip() for _ in range(3)]
b = [input().strip() for _ in range(3)]


 
if can_convert_in_one_move(a, b):
    result = "YES"
else:
    result = "NO"

print(result)