#include <algorithm>
#include <climits>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

int main() {
  int n, m, k;
  int a, b, c, d, e, f, g, o, p, x, y, l, r;
  double u, t;
  bool bl;
  char ch;
  string str;
  cout << setprecision(6) << fixed;
  cin >> n >> k;
  vector<pair<pair<int, int>, bool>> vec(n);
  vector<int> rates(n);
  for (int i = 0; i < n; i++) {
    cin >> rates[i];
  }
  for (int i = 0; i < n; i++) {
    cin >> b;
    vec[i] = {{rates[i], b}, true};
  }
  u = 0;
  f = 0;
  double mx, tmp, tmp2;
  int mx_index;
  p = k / 2;
  for (int i = 0; i < p; i++) {
    mx = 0;
    mx_index = 0;
    for (int j = 0; j < n; j++) {
      if (!vec[j].second)
        continue;
      tmp = (u + vec[j].first.first) / (f + vec[j].first.second);
      if (tmp > mx) {
        mx = tmp;
        mx_index = j;
      } else if (tmp == mx) {
        if (vec[j].first.second < vec[mx_index].first.second) {
          mx_index = j;
        }
      }
    }
    vec[mx_index].second = false;
    u += vec[mx_index].first.first;
    f += vec[mx_index].first.second;
  }
  sort(all(vec),
       [](pair<pair<ll, ll>, bool> first, pair<pair<ll, ll>, bool> second) {
         if (first.second == false)
           return false;
         if (second.second == false)
           return true;
         return ((first.first.first + 0.0) / first.first.second) >
                ((second.first.first + 0.0) / second.first.second);
       });
  for (ll i = 0; i < k - p; i++) {
    u += vec[i].first.first;
    f += vec[i].first.second;
  }
  cout << u / f;
}
