#include <algorithm>
#include <climits>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <unordered_map>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

int main() {
  ll n, m, k;
  ll a, b, c, d, e, f, g, o, p, x, y, l, r;
  bool bl;
  char ch;
  string str;
  cin >> n >> l >> r;
  ll answer = 1;
  vector<ll> vec(n);
  if (r - l < 100) {
    unordered_map<ll, ll> mp;
    for (ll i = 0; i < n; i++) {
      cin >> vec[i];
      a = 0;
      for (ll j = max(0ll, l - vec[i]); j <= r - vec[i]; j++) {
        a = max(a, mp[j]);
      }
      a++;
      answer = max(answer, a);
      mp[vec[i]] = max(mp[vec[i]], a);
    }
  } else {
    set<pair<ll, ll>> segments;
    for (ll i = 0; i < n; i++) {
      cin >> vec[i];
      a = 0;
      if (segments.size() != 0) {
        auto j = segments.end();
        do {
          j--;
          if (l <= j->second + vec[i] && j->second + vec[i] <= r) {
            a = j->first;
            break;
          }
        } while (j != segments.begin());
      }
      a++;
      answer = max(answer, a);
      segments.insert({a, vec[i]});
    }
  }
  cout << answer;
}
