#include <algorithm>
#include <climits>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

int main() {
  ul n, m, k;
  ul a, b, c, d, e, f, g, o, p, x, y, l, r;
  bool bl;
  char ch;
  pair<pair<ul, ul>, bool> tmp_pair;
  cin >> n >> m;
  vector<vector<ul>> list(n);
  ll visited[n];
  ll visitedb[n];
  ul segments = 1;
  for (ul i = 0; i < m; i++) {
    cin >> a >> b;
    a--;
    b--;
    queue<pair<pair<ul, ul>, bool>> *bfs =
        new queue<pair<pair<ul, ul>, bool>>();
    memset(visited, -1, n);
    memset(visitedb, -1, n);
    bfs->push({{a, 0}, true});
    bfs->push({{b, 0}, false});
    e = -1;
    while (!bfs->empty()) {
      tmp_pair = bfs->front();
      bfs->pop();
      if (tmp_pair.second) {
        visited[tmp_pair.first.first] = tmp_pair.first.second;
      } else {
        visitedb[tmp_pair.first.first] = tmp_pair.first.second;
      }
      if (tmp_pair.second && visitedb[tmp_pair.first.first] != -1) {
        e = tmp_pair.first.second + visitedb[tmp_pair.first.first];
        break;
      }
      if (!tmp_pair.second && visited[tmp_pair.first.first] != -1) {
        e = tmp_pair.first.second + visited[tmp_pair.first.first];
        break;
      }
      for (auto child : list[tmp_pair.first.first]) {
        if (!visited[child]) {
          bfs->push({{child, tmp_pair.first.second + 1}, tmp_pair.second});
        }
      }
    }
    free(bfs);
    if (e % 2 == 0) {
      segments++;
      for (ul j = 0; j < n; j++) {
        list[j].clear();
      }
    }
    list[a].push_back(b);
    list[b].push_back(a);
  }
  cout << segments;
}
