#include <algorithm>
#include <climits>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

int main() {
  ul n, m, k;
  ul a, b, c, d, e, f, g, o, p, x, y, l, r;
  bool bl;
  char ch;
  pair<ul, ul> tmp_pair;
  cin >> n >> m;
  vector<vector<ul>> list(n);
  bool visited[n];
  ul segments = 1;
  for (ul i = 0; i < m; i++) {
    cin >> a >> b;
    a--;
    b--;
    queue<pair<ul, ul>> *bfs = new queue<pair<ul, ul>>();
    memset(visited, false, n);
    bfs->push({a, 0});
    e = -1;
    while (!bfs->empty()) {
      tmp_pair = bfs->front();
      bfs->pop();
      if (tmp_pair.first == b) {
        e = tmp_pair.second;
        break;
      }
      for (auto child : list[tmp_pair.first]) {
        if (!visited[child]) {
          bfs->push({child, tmp_pair.second + 1});
          visited[child] = true;
        }
      }
    }
    free(bfs);
    if (((e >> 1)<<1) == e) {
      segments++;
      for (ul j = 0; j < n; j++) {
        list[j].clear();
      }
    }
    list[a].push_back(b);
    list[b].push_back(a);
  }
  cout << segments;
}
