#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,avx,fma,sse4,popcnt")
using namespace std;

#define DIMN 524288

long long tr[2*DIMN];

long long quer(int v, int l, int r, int L, int R) {
    //cout << tr[v] << " " << l << " " << r << " " << L << " " << R << endl;
    if (l > R || r < L) return 0;

    if (L <= l && r <= R) return tr[v];

    int m = (l+r)/2;
    return max(quer(2*v+1,l,m,L,R),quer(2*v+2,m+1,r,L,R));
}

void upd(int v, int l, int r, int tar, long long val) {
    
    if (tar < l || tar > r) return;
    if (l == r) {
        //cout << l << " " << r << " = " << tr[v] << endl;
        tr[v] = val;
        return;
    }
    
    int m = (l+r)/2;
    upd(2*v+1,l,m,tar,val);
    upd(2*v+2,m+1,r,tar,val);
    tr[v] = max(tr[2*v+1],tr[2*v+2]);
    //cout << l << " " << r << " " << tr[v] << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    long long n, ll, rr;
    cin >> n >> ll >> rr;

    vector<long long> a(n);
    vector<long long> b(n);
    unordered_map<long long,int> mp;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        //a[i] = rand()%rr+1;
        b[i] = a[i];
    }
    //for (auto i : a) cout << i << " ";
    sort(b.begin(),b.end());
    for (int i = 0; i < n; i++) mp[b[i]] = i;

    vector<long long> dp(n+1,0);
    set<long long> st;
    st.insert(-1e18);
    st.insert(1e18);

    dp[mp[a[0]]] = 1;
    upd(0,0,n-1,mp[a[0]],1);
    st.insert(a[0]);
    long long res = 1;
    for (int i = 1; i < n; i++) {
        long long lf = ll-a[i];
        long long rf = rr-a[i];
        long long lb, rb;
        lb = *((st.lower_bound(lf)));
        rb = *(prev(st.upper_bound(rf)));

        int l = mp[lb];
        int r = mp[rb];
        if (abs(lb) == 1e18||abs(rb)==1e18) {
            r = -1;
        }
        long long mx = 0; //quer(0,0,n-1,l,r);
        if (n<100000)mx = quer(0,0,n-1,l,r);
        dp[mp[a[i]]] = max(dp[mp[a[i]]],mx+1);
        if (n<100000)upd(0,0,n-1,mp[a[i]],max(dp[mp[a[i]]],mx+1));
        res = max(res,dp[mp[a[i]]]);
        st.insert(a[i]);
    }
    cout << res << endl;
}
