#include <bits/stdc++.h>
using namespace std;

int n, m;
vector<pair<int,int>> a;
vector<int> p;

int par(int x) {
    if (p[x] == x || p[x] == -1) {
        return p[x] = x;
    }
    else return p[x] = par(p[x]);
}

void unit(int u, int v) {
    u = par(u);
    v = par(v);
    p[u] = v;
}

int checkedges(vector<pair<int,int>> v) {
    for (int i = 0; i <= n; i++) p[i] = i;
    for (auto j : v) {
        //cout << j.first << " " << j.second << endl;
        if (par(j.first)==par(j.second)) {
            //cout << 0 << endl;
            return 0;
        }
        else unit(j.first,j.second);
    }
    //cout << 1 << endl;
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    a.resize(m);
    for (int i = 0; i < m; i++) cin >> a[i].first >> a[i].second;
    vector<int> dp(m+1);
    p.resize(n+1);
    dp[0] = 0;
    for (int i = 1; i <= m; i++) {
        for (int j = 0; j <= n; j++) p[j] = j;
        int j = i;
        for (; j > 0; j--) {
            if (par(a[j-1].first)==par(a[j-1].second)) break;
            else unit(a[j-1].first,a[j-1].second);
        }
        dp[i] = min(dp[j],dp[i-1])+1;
        //cout << dp[i] << endl;
    }
    //cout << dp[m];
    vector<pair<int,int>> v;
    int res = m;
    for (int _ = 0; _ < pow(2,m-1); _++) {
        int x = _;
        v.push_back(a[0]);
        int k = 0, p = 0;
        for (int i = 0; i < m-1; i++) {
           // cout << i << " " << x%2 << ":\n";
            if (x%2) {
                if (checkedges(v)==0) {
                    p = 1;
                    break;
                }
                v.clear();
                k++;
            }
            v.push_back(a[i+1]);
            x/=2;
        }
        if (checkedges(v)==0) {
            p = 1;
        }
        v.clear();
        if (!p) res = min(res,k+1);
    }
    cout << res;
}
