#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct song {
    double r, t;
    bool used;
};

bool comp(song a, song b) {
    return a.r/a.t > b.r/b.t;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll n, k;
    double sumr = 0, sumt = 0, numof = 0;
    cin >> n >> k;
    vector<song> songs(n);
    for (ll i = 0; i < n; i++) {
        cin >> songs[i].r;
    }
    for (ll i = 0; i < n; i++) {
        cin >> songs[i].t;
        if (songs[i].r > songs[i].t) {
            numof++;
            sumr += songs[i].r;
            sumt += songs[i].t;
            songs[i].used = true;
        }
    }
    if (numof < k) {
        sort(songs.begin(), songs.end(), comp);
        for (ll i = 0; i < n && numof<k; i++) {
            if (!songs[i].used) {
                numof++;
                sumr += songs[i].r;
                sumt += songs[i].t;
            }
        }
    }
    cout << sumr / sumt << '\n';
}