#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

bool comp(pair<double, ll> a, pair<double, ll> b) {
    return a.first > b.first;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll n, k;
    cin >> n >> k;
    vector<pair<ll, ll>> songs(n);
    vector<pair<double, ll>> halfans(n);
    double sumr = 0, sumt = 0;
    for (ll i = 0; i < n; i++) {
        cin >> songs[i].first;
    }
    for (ll i = 0; i < n; i++) {
        cin >> songs[i].second;
        halfans[i] = { double(songs[i].first) - double(songs[i].second), i };
    }
    sort(halfans.begin(), halfans.end(), comp);
    for (ll i = 0; i < k; i++) {
        sumr += songs[halfans[i].second].first;
        sumt += songs[halfans[i].second].second;
    }
    for (ll i = k + 1; i < n; i++) {
        if ((sumr + songs[halfans[i].second].first) / (sumt + songs[halfans[i].second].second) > sumr / sumt) {
            sumr += songs[halfans[i].second].first;
            sumt += songs[halfans[i].second].second;
        }
        else {
            break;
        }
    }
    cout << sumr / sumt << '\n';
}