#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

//	first - "X", second - "0"
pair<int, int> symbolsCount(vector<string> vec) {
	pair<int, int> result = pair<int, int>(0, 0);
	for (int i = 0; i < vec.size(); i++)
	{
		for (int j = 0; j < vec[i].size(); j++)
		{
			if (vec[i][j] == 'X')
				result.first++;
			if (vec[i][j] == '0')
				result.second++;
		}
	}
	return result;
}

bool isValid(vector<string> field1, vector<string> field2) {
	int diffs = 0;
	
	for (int i = 0; i < field1.size(); i++)
	{
		for (int j = 0; j < field1[i].size(); j++)
		{
			if (field1[i][j] != field2[i][j])
				diffs++;
		}
	}

	if (diffs == 1)
		return true;
	else
		return false;
}


int main()
{
	vector<string> field1(3);
	vector<string> field2(3);
	for (int i = 0; i < 3; i++)
		cin >> field1[i];
	for (int i = 0; i < 3; i++)
		cin >> field2[i];
	if (field1 == field2) {
		cout << "YES";
		return 0;
	}

	//	first - "X", second - "0"
	pair<int, int> countFirst = symbolsCount(field1);
	pair<int, int> countSecond = symbolsCount(field2);

	if (countFirst == countSecond) {
		cout << "NO";
		return 0;
	}
	if (countFirst.first != countFirst.second && countSecond.first != countSecond.second) {
		cout << "NO";
		return 0;
	}
	else if (countFirst.first == countFirst.second && countSecond.first <= countSecond.second) {
		cout << "NO";
		return 0;
	}
	else if(isValid(field1, field2)) {
		cout << "YES";
		return 0;
	}
	else
		cout << "NO";
}
