count, lower, upper = map(int, input().split())
numbers = list(map(int, input().split()))

def longest_subsequence(start = 0, prev = None):
    if start == count - 1:
        return 1 if prev is None else lower <= numbers[start] + prev <= upper

    max_length = 0

    if prev is None:
        for i in range(start, count):
            new_length = longest_subsequence(i + 1, numbers[i]) + 1
            
            if new_length > max_length:
                max_length = new_length

        # print(start, prev, max_length)
        return max_length

    for i in range(start, count):
        if lower <= numbers[i] + prev <= upper:
            new_length = longest_subsequence(i + 1, numbers[i]) + 1
            
            if new_length > max_length:
                max_length = new_length

    # print(start, prev, max_length)
    return max_length

print(longest_subsequence())
