#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

bool bfs(vector<vector<ll>>& v, ll n, ll s) {
    queue<pair<ll,ll>> q;
    vector<bool> u(n + 1, false);
    q.push({ s,0 });
    u[s] = true;
    while (!q.empty()) {
        pair<ll, ll> p = q.front();
        ll vr = p.first, par = p.second;
        q.pop();
        for (ll i = 0; i < v[vr].size(); i++) {
            //cout << u[v[vr][i]] << " " << v[vr][i] << " " << vr << " " << par << endl;
            if (u[v[vr][i]] && v[vr][i] != par) {
                return true;
            }
            else if (!u[v[vr][i]]) {
                q.push({ v[vr][i], vr });
                u[v[vr][i]] = true;
            }
        }
    }
    return false;
}

void solve() {
    ll n, m; cin >> n >> m;
    ll a, b;
    vector<pair<ll, ll>> p(n);
    for (ll i = 0; i < n; i++) {
        cin >> a >> b;
        p[i] = { a,b };
    }
    ll ans = 1;
    vector<vector<ll>> g(n+1);
    for (ll i = 0; i < n; i++) {
        pair<ll, ll> pr = p[i];
        g[pr.first].push_back(pr.second);
        g[pr.second].push_back(pr.first);
        if (bfs(g, n, pr.first)) {
            g.resize(n + 1);
            g[pr.first].push_back(pr.second);
            g[pr.second].push_back(pr.first);
            ans++;
        }
    }
    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
