#include <bits/stdc++.h>
#define int long long
using namespace std;

const int maxn = 5e5 + 10;
const long double eps = 1e-5;

struct node {
    signed a = -1, b = -1;
    signed cur = 0;
} W;
vector <node> tree (1);

inline void update (int i, signed x, int v, int t_l, int t_r) {
    tree[v].cur = max (tree[v].cur, x);
    if (t_l == t_r) return;
    int t_m = t_l + t_r >> 1;
    if (i <= t_m) {
        if (tree[v].a == -1) tree[v].a = (int) tree.size (), tree.push_back (W);
        update (i, x, tree[v].a, t_l, t_m);
    } else {
        if (tree[v].b == -1) tree[v].b = (int) tree.size (), tree.push_back (W);
        update (i, x, tree[v].b, t_m + 1, t_r);
    }
}

inline int get (int l, int r, int v, int t_l, int t_r) {
    if (l > t_r || t_l > r) return 0;
    if (l <= t_l && t_r <= r) return tree[v].cur;
    int t_m = t_l + t_r >> 1;
    if (tree[v].a == -1) tree[v].a = (int) tree.size (), tree.push_back (W);
    if (tree[v].b == -1) tree[v].b = (int) tree.size (), tree.push_back (W);
    return max (get (l, r, tree[v].a, t_l, t_m), 
                get (l, r, tree[v].b, t_m + 1, t_r));
}

int a [maxn], result [maxn];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, l, r;
    cin >> n >> l >> r;
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) {
        int L = max (l - a[i], 1LL), R = r - a[i];
        if (R <= 0) result[i] = 1;
        else result[i] = get (L, R, 0, 1, r) + 1;
        update (a[i], result[i], 0, 1, r);
    }
    int res = 0;
    for (int i = 0; i < n; ++i) res = max (res, result[i]);
    cout << res << '\n';
    return 0;
}
