#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <iomanip>
#include <queue>
#include <map>
#include <unordered_map>
#include <numeric>

using namespace std;

typedef long long lli;
#define LF '\n';

vector<lli> v;
vector<lli> dp;
vector<pair<lli, lli>> v2;
vector<lli> dv;
vector<lli> ind;

lli get(lli a, lli tl, lli tr, lli l, lli r)
{
    if (tl > r || tr < l)return 0;
    if (tl >= l && tr <= r)return dv[a];
    lli tm = (tl + tr) / 2;
    return max(get(a * 2 + 1, tl, tm, l, r), get(a * 2 + 2, tm + 1, tr, l, r));
}

void update(lli a, lli tl, lli tr, lli ind, lli val)
{
    if (tl > ind || tr < ind)return;
    if (tl == tr && tr == ind) {
        dv[a] = val;
        return;
    }
    lli tm = (tl + tr) / 2;
    update(a * 2 + 1, tl, tm, ind, val);
    update(a * 2 + 2, tm+1, tr, ind, val);
    dv[a] = max(dv[a * 2 + 1], dv[a * 2 + 2]);
}

lli findl(lli val,lli n)
{
    lli l = 1;
    lli r = n;
    while (l < r) {
        lli m = (l + r) / 2;
        if (v2[m].first < val)l = m + 1;
        else r = m;
    }
    return l;
}

lli findr(lli val, lli n)
{
    lli l = 1;
    lli r = n;
    while (l < r) {
        lli m = (l + r+1) / 2;
        if (v2[m].first > val)r = m - 1;
        else l = m;
;    }
    return l;
}

void solve()
{
    lli n,l,r;
    cin >> n >> l >> r;
    v.resize(n + 1);
    v2.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> v[i];
    for (int i = 1; i <= n; i++) {
        v2[i].first = v[i];
        v2[i].second = i;
    }
    sort(v2.begin() + 1, v2.end());
    ind.resize(n + 1);
    for (int i = 1; i <= n; i++)ind[v2[i].second] = i;

    dv.resize(4 * n, 0);
    lli ans = 0;
    for (int i = 1; i <= n; i++) {
        lli tl = findl(l-v[i],n);
        lli tr = findr(r-v[i],n);
        lli tres = get(0, 1, n, tl, tr)+1;
        update(0, 1, n, ind[i], tres);
        ans = max(ans, tres);
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

