#define _CRT_SECURE_NO_WARNINGS
#pragma  "Ofast"

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <iomanip>
#include <queue>
#include <map>
#include <unordered_map>
#include <numeric>

using namespace std;

typedef int lli;
#define LF '\n';

struct edge
{
    lli u1, u2;
};

struct mydsu
{
    lli dad, p,mod,s;
};

vector<edge> v;
vector<mydsu> dsu;


lli getdad(lli u)
{
    if (dsu[u].dad == u)return u;
    lli res = getdad(dsu[u].dad);
    return res;
}

lli getmod(lli u)
{
    if (dsu[u].dad == u)return dsu[u].mod;
    return dsu[u].mod ^ getmod(dsu[u].dad);
}

lli getp(lli u)
{
    return dsu[u].p ^ getmod(u);
}

void merge(lli u1, lli u2)
{
    lli d1 = getdad(u1);
    lli d2 = getdad(u2);
    if (dsu[d1].s < dsu[d2].s) {
        swap(d1, d2);
        swap(u2, u1);
    }
    if (getp(u1) == getp(u2)) {
        dsu[d2].mod ^= 1;
    }
    dsu[d1].s += dsu[d2].s;
    dsu[d2].dad = d1;
 //   g[d2].clear();
}

void solve()
{
    lli n, m;
    cin >> n >> m;
    v.resize(m+1);
    dsu.resize(n + 1);
    for (int i = 1; i <= n; i++)dsu[i] = { i,0,0,1 };
    for (int i = 1; i <= m; i++) cin >> v[i].u1 >> v[i].u2;
    lli ans = 1;
    for (int i = 1; i <= m; i++) {
        lli u1 = v[i].u1;
        lli u2 = v[i].u2;
        if (getdad(u1) == getdad(u2)) {
            if (getp(u1) == getp(u2)) {
                ans++;
                for (int i = 1; i <= n; i++)dsu[i] = { i,0,0,1 };
                merge(u1, u2);
            }
        }
        else {
            merge(u1, u2);
        }
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

