#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
struct node{
    int mx;
    node* ls;
    node *rs;
    node(){
        mx = 0;
        ls = 0;
        rs = 0;
    }
};
node* root;
void update(node*&v, ll l,ll r,ll tg,int val){
    if(tg < l or r < tg) return;
    if(v == nullptr){
        v = new node();
    }
    if(l == r){
        v->mx = max(v->mx,val);
        return;
    }
    ll m = (l+r)/2;
    update(v->ls,l,m,tg,val);
    update(v->rs,m+1,r,tg,val);
    if(v->ls) v->mx = max(v->mx,v->ls->mx);
    if(v->rs) v->mx = max(v->mx,v->rs->mx);
}
int get(node *v, ll l,ll r, ll tl, ll tr){
    if(v == nullptr) return 0;
    if(tr < l or r < tl) return 0;
    if(tl <= l and r <= tr) return v->mx;
    ll m = (l+r)/2;
    return max(get(v->ls,l,m,tl,tr),get(v->rs,m+1,r,tl,tr));
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    ll l,r;
    cin >> n >> l >> r;
    int ans = 0;
    vector<ll> a(n);
    map<ll,int> comp;
    for(int i = 0; i < n;i++){
        cin >> a[i];
        comp[a[i]] = 1;
        comp[max(0ll,l-a[i])] = 1;
        comp[max(0ll,r-a[i])] = 1;
    }
    int j = 0;
    for(auto &e:comp){
        e.second = j++;
    }
    for(int i = 0; i < n;i++){
        ll x = a[i];
        ll cx = comp[x];
        int dp = get(root,0,j,comp[max(0ll,l-x)],comp[r-x])+1;
        ans = max(ans,dp);
        update(root,0,j,cx,dp);
    }
    cout << ans << "\n";
}
