#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll n, m, q, k, a, b, c, x, y, l, r;

struct dsu {
    unordered_map<ll, ll> par;
    unordered_map<ll, ll> sz;
    unordered_map<ll, ll> color;
    unordered_map< ll, vector<ll> > st;

    dsu() {
        par = unordered_map<ll, ll>();
        sz = unordered_map<ll, ll>();
        color = unordered_map<ll, ll>();
        st = unordered_map<ll, vector<ll>>();
    }

    void clear() {
        for (auto &i : sz) {
            // cout << "\t\t" << i.first << ' ' << st[i.first].size() << endl;
            st[i.first].clear();
            st.erase(i.first);
        }
        // cout << "\t\tDEBUG" << endl;
        par.clear();
        // cout << "\t\tDEBUG" << endl;
        sz.clear();
        // cout << "\t\tDEBUG" << endl;
        color.clear();
        // cout << "\t\tDEBUG" << endl;
    }

    ll find_p(ll x) {
        if (!par.count(x)) {
            return x;
        }
        ll p = find_p(par[x]);
        par[x] = p;
        return p;
    }

    bool join(ll x, ll y) {
        bool fl = 0;
        if (color[x] == color[y]) {
            fl = 1;
        }
        // cout << '\t' << x << ' ' << y << ' ' << fl << endl;
        x = find_p(x);
        y = find_p(y);
        if (!sz.count(x)) {
            sz[x] = 1;
            st[x].push_back(x);
        }
        if (!sz.count(y)) {
            sz[y] = 1;
            st[y].push_back(y);
        }
        if (x == y) {
            return !fl;
        }
        // cout << '\t' << sz[x] << ' ' << sz[y] << '\n';
        if (sz[x] < sz[y]) {
            swap(x, y);
        }
        sz[x] += sz[y];
        par[y] = x;
        if (fl) {
            for (int i : st[y]) {
                color[i] = 1 - color[i];
            }
        }
        for (int i : st[y]) {
            st[x].push_back(i);
        }
        st[y].clear();
        st.erase(y);
        return 1;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout<<fixed;
    cout<<setprecision(6);

    cin >> n >> m;
    vector< pair<ll, ll> > v(n);
    dsu f;
    ll ans = 1;
    // cout << ans << endl;
    for (int i = 0; i < m; i++) {
        cin >> v[i].first >> v[i].second;
        v[i].first--;
        v[i].second--;
        // cout << "DEBUG" << endl;
        if (!f.join(v[i].first, v[i].second)) {
            // cout << "\tDEBUG" << endl;
            f.clear();
            // cout << "\tDEBUG" << endl;
            f.join(v[i].first, v[i].second);
            ans++;
        }
        // cout << i << '\n';
        // for (auto i : f.color) {
        //     cout << i.first << ' ' << i.second << '\n';
        // }
        // cout << endl;
    }
    // f.clear();
    cout << ans << endl;
}
