#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
const ll INF = 1e6+5, LONGBOI = 1e12+5;
const ld eps = 0.000000000000001;
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

//struct mycomp{
//    bool operator()(ll a, ll b) const {
//        ///
//    }
//};
//
//bool operator < (str &a, str &b){
//
//}

ll n, m, l, r, answer;
ll sz[INF], boss[INF], col[INF];
vector<ll> roads[INF];
set<ll> working;

ll findboss(ll x){
    if(boss[x] == x) return x;
    else boss[x] = findboss(boss[x]);
    return boss[x];
}

ll oppositeColor(ll x){
    if(x == 1) return 2;
    else return 1;
}

void dfs(ll we, ll par, ll newcol){
//    cout << "in dfs we = " << we << " par = " << par << " new col = " << newcol << endl;
    col[we] = newcol;
    newcol = oppositeColor(newcol);
    for(auto x : roads[we]){
        if(x == par) continue;
        dfs(x, we, newcol);
    }
    return;
}

void add(ll x, ll y){
    working.insert(x);
    working.insert(y);
    ll bx = findboss(x);
    ll by = findboss(y);
    //cout << "x = " << x << " boss x = " << bx << " y = " << y << " boss y = " << by << endl;

    if(bx == by){
        if(col[x] == col[y]){
//            cout << "same color for x = " << x << " y = " << y << endl;
//            cout << endl << "-------------------------------------THE END-------------------------------------" << endl << endl;
            for(auto w : working){
                boss[w] = w;
                sz[w] = 1;
                col[w] = 1;
                roads[w].clear();
            }
            working.clear();
            answer++;
            bx = x;
            by = y;
        }
        else return;
    }

//    cout << "size of bx = " << sz[bx] << " size of by = " << sz[by] << endl;
    if(sz[bx] > sz[by]) { swap(bx, by); swap(x, y); }

    sz[by] += sz[bx];
    boss[bx] = by;

    dfs(x, x, oppositeColor(col[y]));

    roads[x].push_back(y);
    roads[y].push_back(x);
//    cout << "added road between x = " << x << " y = " << y << endl;
    return;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m; answer = 1;

    for(int i=1; i <= n; i++){
        sz[i] = 1; boss[i] = i; col[i] = 1;
    }

    for(int i=1; i <= m; i++){
        cin >> l >> r;
        add(l, r);
    }

    cout << answer << endl;
    return 0;
}
