#include <algorithm>
#include <climits>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

int main() {
  unsigned n, m, k;
  unsigned a, b, c, d, e, f, g, o, p, x, y, l, r;
  bool bl;
  char ch;
  pair<unsigned, unsigned> tmp_pair;
  cin >> n >> m;
  vector<vector<unsigned>> list(n);
  vector<bool> visited;
  unsigned segments = 1;
  for (unsigned i = 0; i < m; i++) {
    cin >> a >> b;
    a--;
    b--;
    queue<pair<unsigned, unsigned>> *bfs =
        new queue<pair<unsigned, unsigned>>();
    visited.clear();
    visited.resize(n);
    bfs->push({a, 0});
    e = -1;
    while (!bfs->empty()) {
      tmp_pair = bfs->front();
      bfs->pop();
      if (tmp_pair.first == b) {
        e = tmp_pair.second;
        break;
      }
      for (auto child : list[tmp_pair.first]) {
        if (!visited[child]) {
          bfs->push({child, tmp_pair.second + 1});
          visited[child] = true;
        }
      }
    }
    if (e % 2 == 0) {
      segments++;
      list.clear();
      list.resize(n);
    }
    list[a].push_back(b);
  }
  cout << segments;
}
